﻿namespace Core.ViewModels

open System
open System.Net
open System.Threading
open System.Collections.ObjectModel

open ViewModelSupport

open Core.Models

type MainWindowViewModel() =
    inherit ViewModelBase()

    let parseMovies response : Movie list = 
        []

    let webClient = new WebClient()

    let movieDataUri = new Uri("http://example.rest.endpoint")

    let mutable cancellationSource = new CancellationTokenSource()

    let movies = [
        { Name="movie 1"; Genre="genre 1"; Rating=Some 10}
        { Name="movie 2"; Genre="genre 2"; Rating=None}
        { Name="movie 3"; Genre="genre 3"; Rating=Some 7}
        { Name="movie 4"; Genre="genre 4"; Rating=Some 8}
    ]

    member this.Movies
        with get() =
            base.Get<ObservableCollection<MovieViewModel>>("Movies")

        and set(value) =
            base.Set("Movies", value)

    member this.Execute_GetMovies() =
        this.Movies <- new ObservableCollection<MovieViewModel>()
        this.CancelGetMovies()
        cancellationSource <- new CancellationTokenSource()
    
        let task = async {
            //Psuedo code for connecting to a rest feed and parsing it.
            //for a full example of async being used in a view model
            //see http://bitbucket.org/chrismarinos/gettingyourfunctionalon/src/

            //let! response = webClient.AsyncDownloadString(movieDataUri)
            //let movies = parseMovies response
    
            movies
            |> Seq.map (fun m -> new MovieViewModel(m))
            |> Seq.iter this.Movies.Add
        }
    
        Async.StartImmediate(task, cancellationSource.Token)

    member this.CancelGetMovies() = 
        cancellationSource.Cancel()