﻿namespace GameBrowser.ViewModels
{
    using System;
    using ViewModelSupport;
    using GameBrowser.Models;

    class GameRowViewModel : ViewModelBase
    {
        Game game;

        public GameRowViewModel(Game game)
        {
            this.game = game;
        }

        public Option<BitmapImage> BoxArt 
        {
            get { return game.BoxArt;}
        }

        public string Name
        {
            get { return game.Name; }
        }

        public string Platform
        {
            get { return game.Platform; }
        }


        public Option<string> Genre
        {
            get { return game.Genre; }
        }

        public int Score
        {
            get
            {
                return game.Score.IsSome ? game.Score : 0;
            }
        }

        public bool HasScore
        {
            get{ return game.Score.IsSome; }
        }
    }
}
